#include<stdlib.h>

int comparisons;

void *psearch(void *base, int size, int width, void *element, int (*compare)(void *, void *)) {
	static int depth = 0;

	if(size == 1) {
		return compare(base, element) ? NULL : base;
	}
	else {
		int half, right;
		void *found;

		half = size / 2;
		right = abs(rand()) % 2;
		comparisons = ++depth;
		if(right) {
			found = psearch(base + half * width, size - half, width, element, compare);
			if(! found) {
				found = psearch(base, half, width, element, compare);
			}
		}
		else {
			found = psearch(base, half, width, element, compare);
			if(! found) {
				found = psearch(base + half * width, size - half, width, element, compare);
			}
		}
		--depth;
		return found;
	}
}
