#include<stdio.h>
#include<stdlib.h>
#include<time.h>

#include"psearch.h"

#define DIST_MAX (100)
#define TRIAL_MAX (2048)

#define TABLE_SIZE (512)
int table[TABLE_SIZE];

#define INT_SIZE (sizeof(int))

int icompare(void *element0, void *element1) {
		return *(int *)element0 != *(int *)element1;
}

int main() {
		int dist, trial, pos, sum;

		for(dist = 0; dist < DIST_MAX; dist++) {
				srand(time(NULL) + dist);
				for(pos = 0; pos < TABLE_SIZE; pos++) {
						table[pos] = rand();
				}
				printf("\n dist : %d\n trial\tpos\tdepth", dist);
				sum = 0;
				for(trial = 0; trial < TRIAL_MAX; trial++) {
						pos = abs(rand()) % TABLE_SIZE;
						comparisons = 0;
						psearch(table, TABLE_SIZE, INT_SIZE, table + pos, icompare);
						printf("\n%d\t%d\t%d", trial, pos, comparisons);
						sum += comparisons;
				}
				printf("\nAvg depth : %d", sum / TRIAL_MAX);
		}
}
